<template>
  <div>
    <div class="page-content">
      <page-header>
        <div class="container-fluid">
          <div class="row">
            <div class="col-9 col-xl-6 offset-xl-3">
              <search-bar></search-bar>
            </div>
            <div class="col-3 col-lg-3">
              <div
                class="page-header-item-wrapper"
                style="height:70px; display:flex; align-items: center;"
              >
                <button class="button block" @click="createProject">
                  Create project
                </button>
              </div>
            </div>
          </div>
        </div>
      </page-header>
      <div class="container-fluid">
        <div class="row">
          <div class="col-sm-12 col-xl-6 offset-xl-3">
            <div class="page-title">
              Projects
            </div>
            <div class="projects-list" v-if="projects.length > 0">
              <project
                :project="project"
                v-for="project in projects"
                :key="project.id"
              ></project>
            </div>
            <div class="projects-list" v-else>
              <div class="project">
                <div class="noprojects">
                  <img src="../../assets/startup.svg" />
                  <div>
                    You don't have any projects yet,
                    <span @click="createProject">create a project</span>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import store from "../../store";
import { mapState } from "vuex";
import CreateProject from "../../components/modals/CreateProject";
import Project from "./Project";
export default {
  components: {
    Project
  },
  beforeRouteEnter(to, from, next) {
    store.dispatch("projectModule/getProjects").then(() => {
      next();
    });
  },
  methods: {
    openProject(id) {
      this.$router.push({ name: "Project", params: { id } });
    },
    createProject() {
      this.$modal.show(CreateProject);
    }
  },
  computed: mapState("projectModule", ["projects"])
};
</script>

<style lang="scss">
.projects-list {
  .project {
    display: flex;
    flex-direction: column;
    border: 1px solid #e0e0e0;
    background-color: #f3f3f3;
    border-radius: 8px;
    margin-bottom: 30px;
    transition: background-color 0.1s ease-out, border-color 0.1s ease-out;
    &:hover{
      cursor:pointer;
    }
    .project-heading {
      border-bottom: 1px solid #e0e0e0;
      display: flex;
      padding-right: 10px;
      transition: border-color 0.1s ease-out;
      .title {
        flex: 1;
        display: flex;
        align-items: center;
        padding: 20px;
        font-size: 23px;
        color: #4c4e57;
        font-weight: 600;
        .image {
          width: 40px;
          height: 40px;
          background-color: red;
          border-radius: 6px;
          overflow: hidden;
          margin-right: 10px;
          text-align: center;
          font-size: 20px;
          line-height: 40px;
          color: #f4f4f4;
          text-shadow: 1px 1px 1px rgba(150, 150, 150, 0.3);
          img {
            width: 100%;
            height: 100%;
          }
        }
      }
      .issues {
        display: flex;
        justify-content: center;
        align-items: center;
        padding-left: 10px;
        padding-right: 10px;
        font-weight: 600;
        i {
          margin-right: 5px;
        }
        margin-right: 10px;
      }
      .members {
        display: flex;
        justify-content: center;
        align-items: center;
        padding-left: 10px;
        padding-right: 10px;
        font-weight: 600;
        i {
          margin-right: 4px;
        }
      }
    }
    .project-repositories {
      color: #a5a5a5;
      font-weight: 600;
      padding: 10px;
      .project-repository {
        display: flex;
        .icon {
          font-size: 16px;
          padding-left: 10px;
          padding-right: 10px;
          color: #585e66;
        }
        .name {
          font-size: 16px;
          font-weight: 600;
          padding-left: 10px;
          padding-right: 10px;
          color: #585e66;
        }
      }
    }
  }
  .noprojects {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    padding: 20px;
    color: #4c4e57;
    font-weight: bold;
    img {
      height: 200px;
      margin-bottom: 20px;
    }
    span {
      text-decoration: underline;
      &:hover {
        color: #383940;
        cursor: pointer;
      }
    }
  }
}
#app {
  background-color: #f6f6f6;
  &.darkMode {
    .projects-list {
      .project {
        background-color: #293039;
        border-color: #25282e;
        .project-heading {
          border-color: #25282e;
          .title {
            color: #a7b7c9;
          }
          .issues {
            color: #a7b7c9;
          }
          .members {
            color: #a7b7c9;
          }
        }
        .project-repositories {
          color: #576474;
          .project-repository {
            .icon {
              color: #4f5e75;
            }
            .name {
              color: #4f5e75;
            }
          }
        }
      }
      .noprojects {
        color: #a7b7c9;
        span {
          &:hover {
            color: #788799;
            cursor: pointer;
          }
        }
      }
    }
  }
}
</style>
